"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var path = require("path");
var _ = require("lodash");
var child_process_1 = require("child_process");
var fs = require("fs");
var TscPathsPlugin = /** @class */ (function () {
    function TscPathsPlugin(serverless, options) {
        var _this = this;
        this.isWatching = false;
        this.hookCalled = false;
        this.serverless = serverless;
        this.options = options;
        this.isDebug = typeof process.env.SLS_DEBUG !== 'undefined';
        this.rootPath = this.serverless.config.servicePath;
        var config = _.merge({
            buildPath: '.build',
            tsconfigPath: 'tsconfig.json',
            tscpathsPath: 'node_modules/@baemingo/tscpaths-async',
        }, this.serverless.service.custom.tscpaths);
        this.buildPath = path.join(this.rootPath, config.buildPath);
        this.tscpathsPath = path.join(this.rootPath, config.tscpathsPath);
        this.tsconfigPath = path.join(this.rootPath, config.tsconfigPath);
        this.hooks = {
            'after:invoke:local:invoke': function () {
                if (_this.options.watch) {
                    _this.watchAll();
                }
            },
            'before:deploy:function:packageFunction': function () { return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.hook()];
                        case 1:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            }); },
            'before:invoke:local:invoke': function () { return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.hook()];
                        case 1:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            }); },
            'before:offline:start': function () { return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.hook()];
                        case 1:
                            _a.sent();
                            this.watchAll();
                            return [2 /*return*/];
                    }
                });
            }); },
            'before:offline:start:init': function () { return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.hook()];
                        case 1:
                            _a.sent();
                            this.watchAll();
                            return [2 /*return*/];
                    }
                });
            }); },
            'before:package:createDeploymentArtifacts': function () { return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.hook()];
                        case 1:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            }); },
            'before:run:run': function () { return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.hook()];
                        case 1:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            }); },
        };
    }
    TscPathsPlugin.prototype.watchAll = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                if (this.isWatching) {
                    return [2 /*return*/];
                }
                this.serverless.cli.log("Ready to fix paths in changed files...");
                this.isWatching = true;
                this.watchFiles(this.watchCallback.bind(this));
                return [2 /*return*/];
            });
        });
    };
    TscPathsPlugin.prototype.watchCallback = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this.hookCalled) {
                            return [2 /*return*/];
                        }
                        this.hookCalled = true;
                        return [4 /*yield*/, this.hook()];
                    case 1:
                        _a.sent();
                        this.hookCalled = false;
                        return [2 /*return*/];
                }
            });
        });
    };
    TscPathsPlugin.prototype.getFilesPaths = function () {
        var _this = this;
        return this.serverless.service
            .getAllFunctions()
            .map(function (fn) { return _this.serverless.service.getFunction(fn).handler; })
            .reduce(function (acc, h) {
            var fnName = _.last(h.split('.'));
            var fnNameLastAppearanceIndex = h.lastIndexOf(fnName);
            // replace only last instance to allow the same name for file and handler
            var fileName = h.substring(0, fnNameLastAppearanceIndex);
            // Check if the .js files exists. If so return that to watch
            var pathTofile = path.join(_this.buildPath, fileName + 'js');
            if (fs.existsSync(pathTofile)) {
                acc.push(pathTofile);
            }
            return acc;
        }, []);
    };
    TscPathsPlugin.prototype.watchFiles = function (cb) {
        var watchedFiles = this.getFilesPaths();
        watchedFiles.forEach(function (fileName) {
            fs.watchFile(fileName, { persistent: true, interval: 250 }, watchCallback);
        });
        function watchCallback(curr, prev) {
            // Check timestamp
            if (+curr.mtime <= +prev.mtime) {
                return;
            }
            cb();
        }
    };
    TscPathsPlugin.prototype.hook = function () {
        return __awaiter(this, void 0, void 0, function () {
            var flag, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.serverless.cli.log('Fixing paths');
                        flag = this.isDebug ? '--verbose' : '';
                        return [4 /*yield*/, this.exec(
                            // tslint:disable-next-line: max-line-length
                            "node \"" + this.tscpathsPath + "\" -p \"" + this.tsconfigPath + "\" -s \"" + this.rootPath + "\" -o \"" + this.buildPath + "\" " + flag)];
                    case 1:
                        result = _a.sent();
                        this.serverless.cli.log('Paths fixed');
                        return [2 /*return*/, result];
                }
            });
        });
    };
    TscPathsPlugin.prototype.exec = function (cmd) {
        return __awaiter(this, void 0, void 0, function () {
            var child;
            return __generator(this, function (_a) {
                child = child_process_1.spawn(cmd, {
                    shell: true,
                    stdio: 'inherit',
                });
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        child.on('close', function (code) {
                            code ? reject(code) : resolve();
                        });
                    })];
            });
        });
    };
    return TscPathsPlugin;
}());
exports.TscPathsPlugin = TscPathsPlugin;
module.exports = TscPathsPlugin;
